io.vertx.rxjava.core.http

## Class WebSocket

- java.lang.Object
- - io.vertx.rxjava.core.http.WebSocket

- All Implemented Interfaces:
    WebSocketBase, ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public class WebSocket
      extends Object
      implements WebSocketBase

  Represents a client-side WebSocket.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<WebSocket>` | `__TYPE_ARG`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WebSocket(WebSocket delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `binaryHandlerID()` When a `Websocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.
    `WebSocketBase` | `binaryMessageHandler(Handler<Buffer> handler)` Set a binary message handler on the connection.
    `void` | `close()` Close the WebSocket sending the default close frame.
    `void` | `close(short statusCode)`
    `void` | `close(short statusCode, String reason)`
    `WebSocket` | `closeHandler(Handler<Void> handler)` Set a close handler.
    `WebSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Calls `WebSocketBase.close()`
    `void` | `end(Buffer t)` Same as `WebSocketBase.end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
    `WebSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `boolean` | `equals(Object o)`
    `WebSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `WebSocket` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `WebSocket` | `frameHandler(Handler<WebSocketFrame> handler)` Set a frame handler on the connection.
    `WebSocket` | `getDelegate()`
    `WebSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `int` | `hashCode()`
    `boolean` | `isSsl()`
    `SocketAddress` | `localAddress()`
    `static WebSocket` | `newInstance(WebSocket arg)`
    `WebSocket` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `WebSocketBase` | `pongHandler(Handler<Buffer> handler)` Set a pong message handler on the connection.
    `SocketAddress` | `remoteAddress()`
    `WebSocket` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `WebSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `SSLSession` | `sslSession()`
    `String` | `subProtocol()` Returns the websocket sub protocol selected by the websocket handshake.
    `String` | `textHandlerID()` When a `Websocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.
    `WebSocketBase` | `textMessageHandler(Handler<String> handler)` Set a text message handler on the connection.
    `Observable<Buffer>` | `toObservable()`
    `String` | `toString()`
    `io.vertx.rx.java.WriteStreamSubscriber<Buffer>` | `toSubscriber()`
    `WebSocket` | `write(Buffer data)` Write some data to the stream.
    `WebSocket` | `writeBinaryMessage(Buffer data)` Writes a (potentially large) piece of binary data to the connection.
    `WebSocket` | `writeFinalBinaryFrame(Buffer data)` Write a final WebSocket binary frame to the connection
    `WebSocket` | `writeFinalTextFrame(String text)` Write a final WebSocket text frame to the connection
    `WebSocket` | `writeFrame(WebSocketFrame frame)` Write a WebSocket frame to the connection
    `WebSocketBase` | `writePing(Buffer data)` Writes a ping to the connection.
    `WebSocketBase` | `writePong(Buffer data)` Writes a pong to the connection.
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
    `WebSocket` | `writeTextMessage(String text)` Writes a (potentially large) piece of text data to the connection.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.rxjava.core.http.WebSocketBase

      `newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.ReadStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.WriteStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.StreamBase

      `newInstance`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<WebSocket> __TYPE_ARG

  - ### Constructor Detail

    - #### WebSocket

          public WebSocket(WebSocket delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public WebSocket getDelegate()

      Specified by:
        `getDelegate` in interface `WebSocketBase`
      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### toSubscriber

          public io.vertx.rx.java.WriteStreamSubscriber<Buffer> toSubscriber()

    - #### end

          public void end(Buffer t)

      Same as `WebSocketBase.end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `t` -

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WebSocketBase`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        true if write queue is full

    - #### binaryHandlerID

          public String binaryHandlerID()

      When a `Websocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.

      Given this ID, a different event loop can send a binary frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `binaryHandlerID` in interface `WebSocketBase`
      Returns:
        the binary handler id

    - #### textHandlerID

          public String textHandlerID()

      When a `Websocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.

      Given this ID, a different event loop can send a text frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `textHandlerID` in interface `WebSocketBase`
      Returns:

    - #### subProtocol

          public String subProtocol()

      Returns the websocket sub protocol selected by the websocket handshake.

      On the server, the value will be `null` when the handler receives the websocket callback as the handshake will not be completed yet.
      Specified by:
        `subProtocol` in interface `WebSocketBase`
      Returns:

    - #### writePing

          public WebSocketBase writePing(Buffer data)

      Writes a ping to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section 5.5.2.

      There is no pingHandler because RFC 6455 section 5.5.2 clearly states that the only response to a ping is a pong with identical contents.

      Specified by:
        `writePing` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a reference to this, so the API can be used fluently

    - #### writePong

          public WebSocketBase writePong(Buffer data)

      Writes a pong to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section 5.5.2.

      There is no need to manually write a Pong, as the server and client both handle responding to a ping with a pong automatically and this is exposed to users.RFC 6455 Section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Specified by:
        `writePong` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a reference to this, so the API can be used fluently

    - #### textMessageHandler

          public WebSocketBase textMessageHandler(Handler<String> handler)

      Set a text message handler on the connection. This handler will be called similar to the , but the buffer will be converted to a String first
      Specified by:
        `textMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryMessageHandler

          public WebSocketBase binaryMessageHandler(Handler<Buffer> handler)

      Set a binary message handler on the connection. This handler serves a similar purpose to `handler(io.vertx.core.Handler<io.vertx.rxjava.core.buffer.Buffer>)` except that if a message comes into the socket in multiple frames, the data from the frames will be aggregated into a single buffer before calling the handler (using `WebSocketFrame.isFinal()` to find the boundaries).
      Specified by:
        `binaryMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### pongHandler

          public WebSocketBase pongHandler(Handler<Buffer> handler)

      Set a pong message handler on the connection. This handler will be invoked every time a pong message is received on the server, and can be used by both clients and servers since the RFC 6455 Sections 5.5.2 and 5.5.3 do not specify whether the client or server sends a ping.

      Pong frames may be at most 125 bytes (octets).

      There is no ping handler since pings should immediately be responded to with a pong with identical content

      Pong frames may be received unsolicited.

      Specified by:
        `pongHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### end

          public void end()

      Calls `WebSocketBase.close()`
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          public void close()

      Close the WebSocket sending the default close frame.

      No more messages can be sent.
      Specified by:
        `close` in interface `WebSocketBase`

    - #### close

          public void close(short statusCode)

      Specified by:
        `close` in interface `WebSocketBase`

    - #### close

          public void close(short statusCode,
                            String reason)

      Specified by:
        `close` in interface `WebSocketBase`

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Specified by:
        `remoteAddress` in interface `WebSocketBase`
      Returns:
        the remote address for this socket

    - #### localAddress

          public SocketAddress localAddress()

      Specified by:
        `localAddress` in interface `WebSocketBase`
      Returns:
        the local address for this socket

    - #### isSsl

          public boolean isSsl()

      Specified by:
        `isSsl` in interface `WebSocketBase`
      Returns:
        true if this `HttpConnection` is encrypted via SSL/TLS.

    - #### exceptionHandler

          public WebSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `WebSocketBase`
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public WebSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `WebSocketBase`
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public WebSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `WebSocketBase`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public WebSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `WebSocketBase`
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public WebSocket fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `WebSocketBase`
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public WebSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `WebSocketBase`
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public WebSocket write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WebSocketBase`
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public WebSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WebSocketBase`
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public WebSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WebSocketBase`
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFrame

          public WebSocket writeFrame(WebSocketFrame frame)

      Description copied from interface: `WebSocketBase`
      Write a WebSocket frame to the connection
      Specified by:
        `writeFrame` in interface `WebSocketBase`
      Parameters:
        `frame` - the frame to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFinalTextFrame

          public WebSocket writeFinalTextFrame(String text)

      Description copied from interface: `WebSocketBase`
      Write a final WebSocket text frame to the connection
      Specified by:
        `writeFinalTextFrame` in interface `WebSocketBase`
      Parameters:
        `text` - The text to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFinalBinaryFrame

          public WebSocket writeFinalBinaryFrame(Buffer data)

      Description copied from interface: `WebSocketBase`
      Write a final WebSocket binary frame to the connection
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocketBase`
      Parameters:
        `data` - The data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeBinaryMessage

          public WebSocket writeBinaryMessage(Buffer data)

      Description copied from interface: `WebSocketBase`
      Writes a (potentially large) piece of binary data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `writeBinaryMessage` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeTextMessage

          public WebSocket writeTextMessage(String text)

      Description copied from interface: `WebSocketBase`
      Writes a (potentially large) piece of text data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `writeTextMessage` in interface `WebSocketBase`
      Parameters:
        `text` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          public WebSocket closeHandler(Handler<Void> handler)

      Description copied from interface: `WebSocketBase`
      Set a close handler. This will be called when the WebSocket is closed.

      After this callback, no more messages are expected.
      Specified by:
        `closeHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          public WebSocket frameHandler(Handler<WebSocketFrame> handler)

      Description copied from interface: `WebSocketBase`
      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Specified by:
        `frameHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### sslSession

          public SSLSession sslSession()

      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.

    - #### newInstance

          public static WebSocket newInstance(WebSocket arg)

Copyright © 2018 Eclipse. All rights reserved.